function init()
	up = FindShapes("skyUp", true)
	down = FindShapes("skyDown", true)
	stop = FindShapes("skyStop", true)
	motor = FindJoint("skyMotor", true)
	cabin = FindShape("skyCabin", true)
	
	tele = FindShape("towerRoof", true)
	teleLoc1 = FindLocation("towerRoof", true)
	
	liftTop = FindTrigger("skyTop", true)
	liftBottom = FindTrigger("skyBottom", true)
	
	doors1 = FindJoints("elJoint2", true)
	
	motorRun = LoadLoop("vehicle/hydraulic-loop.ogg")
	chime = LoadSound("elevator-chime.ogg")
	
	
	doorSpeed = 0
	speed = 0
	
	
	for i=1,#up do
		SetTag(up[i], "interact", "Up")
	end

	for i=1,#down do
		SetTag(down[i], "interact", "Down")
	end
	
	for i=1,#stop do
		SetTag(stop[i], "interact", "Stop")
	end


	movingUp = false
	movingDown = false



end

function moveUp()
	movingDown = false
	SetJointMotor(motor, -speed - 2) --lift speed, up.
end

function moveDown()
	movingUp = false
	SetJointMotor(motor, speed + 2) --lift speed, down.
end

function stopMoving()
local motorPos = GetShapeWorldTransform(cabin).pos
	SetJointMotor(motor, speed)
	movingUp = false
	movingDown = false
	PlaySound(chime, motorPos) --Plays a chime when the elevator stops.
end

function tick(dt)
local motorPos = GetShapeWorldTransform(cabin).pos

	for i=1,#up do
		if GetPlayerInteractShape() == up[i] and InputPressed("interact") then
			movingUp = true
			moveUp()
		end
	end

	for i=1,#down do
		if GetPlayerInteractShape() == down[i] and InputPressed("interact") then
			movingDown = true
			moveDown()
		end
	end
	
	for i=1,#stop do
		if GetPlayerInteractShape() == stop[i] and InputPressed("interact") then
			stopMoving()
		end
	end
	
	if movingUp or movingDown then
		PlayLoop(motorRun, motorPos)
	end
	
	if IsPointInTrigger(liftTop, motorPos) and movingUp then
		stopMoving()
	elseif IsPointInTrigger(liftBottom, motorPos) and movingDown then
		stopMoving()
	end
	
	doorLoop()
end

function doorLoop() --this is the loop for the elevator doors.

	for i=1,#doors1 do
		if movingDown == false and movingUp == false then
			SetJointMotor(doors1[i], doorSpeed + 0.5)
		else
			SetJointMotor(doors1[i], doorSpeed - 0.5)
		end
	end
end



--work in progress.